package Interface.MultiCapas;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.ArrayList;

import javax.swing.JOptionPane;
import javax.swing.JPanel;

import Map.Concept;

public class ReglasDifusas {

	private Float peso;
	private ArrayList<Concept> paramteros;
	private Concept destino;
	private int idMapaDetino;
	private String rutaArcivo;
	private Boolean error = false;
	private String mensajeError;

	public ReglasDifusas(ArrayList<Concept> paramteros, Concept destino,
			int idMapaDetino, String rutaArcivo) {

		this.paramteros = paramteros;
		this.destino = destino;
		this.idMapaDetino = idMapaDetino;
		this.rutaArcivo = rutaArcivo;

	}

	public void calcularPeso() {
		actualizarArcivo();
		ejecutarConsola();
	}

	private void actualizarArcivo() {
		try {
			File archivo = new File("reglasDifusas.m");
			BufferedWriter escribir = new BufferedWriter(
					new FileWriter(archivo));
			escribir.write("pkg load fuzzy-logic-toolkit\r\n");
			escribir.write("fis = readfis ('" + rutaArcivo + "');\r\n");
			escribir.write("evalfis (" + agrupar() + ", fis)\r\n");
			escribir.close();
		} catch (Exception e) {
			System.out.println("Error al escribir");
		}
	}

	private void ejecutarConsola() {
		String s = null;
		ArrayList<String> listElem = new ArrayList<String>();
		try {
			Runtime command = Runtime.getRuntime();
			Process pr = command.exec("octave -q reglasDifusas.m");
			BufferedReader stdInput = new BufferedReader(new InputStreamReader(
					pr.getInputStream()));
			BufferedReader stdError = new BufferedReader(new InputStreamReader(
					pr.getErrorStream()));
			while ((s = stdInput.readLine()) != null) {
				listElem.add(s);
			}
			if (pr.waitFor() != 0) {
				mensajeError = stdError.readLine();
				while ((s = stdError.readLine()) != null) {
					System.out.println(s);
				}
				error = true;
			} else {
				String[] e = listElem.get(listElem.size() - 1).split("=");
				peso = Float.parseFloat(e[e.length - 1]);
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private String agrupar() {
		String dato = "";
		for (Concept c : paramteros) {
			dato = dato + " " + c.getCurrentValue();
		}
		dato = "[" + dato + "]";
		return dato;
	}

	public Float getPeso() {
		return peso;
	}

	public void setPeso(Float peso) {
		this.peso = peso;
	}

	public ArrayList<Concept> getParamteros() {
		return paramteros;
	}

	public void setParamteros(ArrayList<Concept> paramteros) {
		this.paramteros = paramteros;
	}

	public Concept getDestino() {
		return destino;
	}

	public void setDestino(Concept destino) {
		this.destino = destino;
	}

	public int getIdMapaDetino() {
		return idMapaDetino;
	}

	public void setIdMapaDetino(int idMapaDetino) {
		this.idMapaDetino = idMapaDetino;
	}

	public Boolean getError() {
		return error;
	}

	public void mostrarError(JPanel panel) {
		JOptionPane jop = new JOptionPane();
		jop.showMessageDialog(
				panel,
				mensajeError
						+ "\r\nPosible solucion:\r\nVerificar archivo .fis(contenido del archivo y si se Cargo)."
						+ "\r\nVerificar la cantidad de variables imput creadas."
						+ "\r\nVerificar si las variables impuct pertenecen al rango del conjuto difuso )"
						+ "\r\nVerificar que el panel variables del sistema difuso no este vacio)",
				"Error en Construccion de Reglas Difusas",
				JOptionPane.ERROR_MESSAGE);
	}
}
