package Interface.Options;

/**
 * OpcionesNodos.java
 * Este Frame crea una ventana para acceder a las distintas opciones
 * para cambiar los parametros de los conceptos
 * Created on 1 de febrero de 2005, 0:01
 * @author Jos Bladimir Contreras Vargas
 * @author <A HREF="mailto:jbc_ve@hotmail.com">jbc_ve@hotmail.com</A>
 */
public class ConceptOptions extends javax.swing.JFrame {
 
    /**
     * Boton para aceptar los cambios para el concepto al presionar este boton los cambios son efectuados y la ventana se cierra
     */
    private javax.swing.JButton botonAceptar;    
    /**
     * Boton para cancelar los cambios en el concepto al presionar este boton los cambios
     * no se realizan y la ventana se cierra
     */
    private javax.swing.JButton botonCancelar;   
    /**
     * Indica si la etiqueta del concepto debe estar abajo
     */
    private java.awt.Checkbox labelDown;    
    /**
     * Indica si la etiqueta del concepto debe estar arriba
     */
    private java.awt.Checkbox labelUp;    
    /**
     * Indica si la etiqueta del concepto debe estar a un lado
     */
    private java.awt.Checkbox labelRSide;
    /**
     * Indica si la etiqueta del concepto debe estar a un lado
     */
    private java.awt.Checkbox labelLSide;
    /**
     * Indica el nombre del concepto
     */
    private javax.swing.JTextField nombreText;    
    /**
     * Indica el Valor del Concepto
     */
    private javax.swing.JTextField valorText;    
    /**
     * Entrada para el comentario de expicacin del concepto
     */
    private java.awt.TextArea comentario;    
    /**
     * Concepto a modificar
     */
    private Map.Concept concept;    
    /**
     * lienzo donde el concepto esta dibujado
     */
    private java.awt.Canvas canvasToRepaint;
    
    /**
     * Crea una nueva ventana con las opciones para los Conceptos
     * @param concept Concepto al cual se acceden las opciones
     * @param canvas Lienzo donde esta dibujado el conceptos
     */
    public ConceptOptions( Map.Concept concept , java.awt.Canvas canvas ) { 
        this.concept = concept;
        this.canvasToRepaint = canvas; 
        this.initComponents();
    }
    
    /**
     * Esta funcion inicializa los componentes y muestra la ventana
     */
    private void initComponents() {
        
        javax.swing.JLabel etiqueta;
        
        this.getContentPane().setLayout(null);
        this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        etiqueta = new javax.swing.JLabel("Identificador del Concepto:");
        etiqueta.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        this.getContentPane().add(etiqueta);
        etiqueta.setBounds(20, 20, 170, 14);

        etiqueta = new javax.swing.JLabel("" + this.concept.getConceptID() );
        this.getContentPane().add(etiqueta);
        etiqueta.setBounds(190, 20, 40, 14);

        etiqueta = new javax.swing.JLabel("Nombre:");
        etiqueta.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        this.getContentPane().add(etiqueta);
        etiqueta.setBounds(10, 50, 60, 19);
        
        nombreText = new javax.swing.JTextField( this.concept.getName() );
        this.getContentPane().add(nombreText);
        nombreText.setBounds(70, 50, 100, 19);

        etiqueta = new javax.swing.JLabel("Valor Inicial:");
        etiqueta.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        this.getContentPane().add(etiqueta);
        etiqueta.setBounds(10, 80, 80, 19);
        
        valorText = new javax.swing.JTextField( "" + this.concept.getInitialValue() );   
        this.getContentPane().add(valorText);
        valorText.setBounds(90, 80, 60, 19);

        etiqueta = new javax.swing.JLabel("Valor Actual:");
        etiqueta.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        this.getContentPane().add(etiqueta);
        etiqueta.setBounds(10, 110, 80, 14);
        
        etiqueta = new javax.swing.JLabel(""+this.concept.getCurrentValue() );
        this.getContentPane().add(etiqueta);
        etiqueta.setBounds(90, 110, 80, 14);

        etiqueta = new javax.swing.JLabel( "Posicion del Nombre:" );
        etiqueta.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        this.getContentPane().add(etiqueta);
        etiqueta.setBounds(10, 140, 140, 14);
        
        java.awt.CheckboxGroup groupLabelPosition = new java.awt.CheckboxGroup();   
        
        labelUp = new java.awt.Checkbox( "Arriba" , groupLabelPosition , (this.concept.getLabelPosition() == this.concept.ARRIBA) ); 
        this.getContentPane().add(labelUp);
        labelUp.setBounds(90, 160, 90, 23);

        labelRSide = new java.awt.Checkbox( "Derecha" , groupLabelPosition , (this.concept.getLabelPosition() == this.concept.RSIDE) ); 
        this.getContentPane().add(labelRSide);
        labelRSide.setBounds(130, 180, 90, 23);
        
        labelLSide = new java.awt.Checkbox( "Izquierda" , groupLabelPosition , (this.concept.getLabelPosition() == this.concept.LSIDE) ); 
        this.getContentPane().add(labelLSide);
        labelLSide.setBounds(50, 180, 90, 23);
        
        labelDown = new java.awt.Checkbox( "Abajo" , groupLabelPosition , (this.concept.getLabelPosition() == this.concept.ABAJO) ); 
        this.getContentPane().add(labelDown);
        labelDown.setBounds(90, 200, 90, 23);
        
        etiqueta = new javax.swing.JLabel( "Comentario:" );
        etiqueta.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        this.getContentPane().add(etiqueta);
        etiqueta.setBounds( 10 , 220 , 140 , 14 );
        
        comentario = new java.awt.TextArea ( this.concept.getComentario() );
        this.getContentPane().add(comentario);
        comentario.setBounds( 10 , 240 , 230 , 100 );
        
        botonAceptar = new javax.swing.JButton("Aceptar");
        botonAceptar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botonAceptarMouseClicked(evt);
            }
        });

        this.getContentPane().add(botonAceptar);
        botonAceptar.setBounds(20, 355, 90, 23);

        botonCancelar = new javax.swing.JButton("Cancelar");
        botonCancelar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ConceptOptions.this.dispose();
            }
        });
   
        this.getContentPane().add(botonCancelar);
        botonCancelar.setBounds(120, 355, 90, 23);

        this.setSize( 250, 420);
        this.setLocation( 50 , 50 );
        this.setTitle("Opciones del Concepto");
    }
     
    /**
     * Esta funcion ejecuta la accion de aceptar los cambios al concepto
     * @param evt Evento que se genera al presionar el boton Aceptar
     */
    private void botonAceptarMouseClicked(java.awt.event.MouseEvent evt) {
        this.concept.setName( this.nombreText.getText() );
        this.concept.setInitialValue( Float.valueOf( this.valorText.getText() ) );
        this.concept.setCurrentValue( Float.valueOf( this.valorText.getText() ) );
        this.concept.setComentario( this.comentario.getText() );
        
        if ( this.labelUp.getState() )
            this.concept.setLabelPosition( this.concept.ARRIBA );
        else if ( this.labelDown.getState() )
            this.concept.setLabelPosition( this.concept.ABAJO );
        else if ( this.labelRSide.getState() )
            this.concept.setLabelPosition( this.concept.RSIDE );
        else
            this.concept.setLabelPosition( this.concept.LSIDE );
        
        this.canvasToRepaint.repaint();
        this.dispose();     
    } 
}
