package Interface.Options;

import Interface.*;


/**
 * Ventana para asignar el retardo durante la ejecucin del mapa
 * Created on 13 de febrero de 2005, 16:16
 * @author Jos Bladimir Contreras Vargas
 * @author <A HREF="mailto:jbc_ve@hotmail.com">jbc_ve@hotmail.com</A>
 */
public class DelayOptions extends javax.swing.JFrame {
    /**
     * Area de texto para colocar el retardo deseado en milisegundos
     */
    java.awt.TextField texto = new java.awt.TextField("Retardo Positivo");
    /**
     * Boton para aceptar y asignar el retardo
     */
    java.awt.Button aceptar = new java.awt.Button("Aceptar");
    /**
     * boton para cancelar los cambios
     */
    java.awt.Button cancelar = new java.awt.Button("Cancelar");
    /**
     * Hilo de jeceucion al cual se le va asiganr el retardo
     */
    Algorithms.RunFCM hilo;
    /**
     * Crea la Ventana para asignar el retardo
     * @param hilo Hilo de jecucin al cual se le va asignar el retardo
     */
    public DelayOptions(Algorithms.RunFCM hilo) {
        Interface.LPanel panel = new Interface.LPanel();
        panel.addComponent( new java.awt.Label("Retardo") , 1 , 0 , 1.0 , 1.0 , 0 , 0 );
        panel.addComponent( this.texto , 0 , 0 , 1.0 , 1.0 , 0 , 0 );
        panel.addComponent( this.aceptar, 1 , 0 , 1.0 , 1.0 , 0 , 0 );
        panel.addComponent( this.cancelar, 0 , 0 , 1.0 , 1.0 , 0 , 0 );
        this.add(panel);
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        this.aceptar.addMouseListener( new escucha() );
        this.cancelar.addMouseListener( new escucha() );
        this.pack();
        this.hilo = hilo;
        this.texto.setText(""+this.hilo.getRetardo() );
        this.setTitle("Opciones de Retardo");
        this.setVisible(true);
        
    }
    
    /**
     * Objeto para escuchar cuando se presiona el boton aceptar
     */
    private class escucha extends java.awt.event.MouseAdapter {
        /**
         * Evento de presionar el boton aceptar
         * @param evt evento de presionar el Boton aceptar
         */
        public void mouseClicked(java.awt.event.MouseEvent evt) {
            if ( evt.getSource().equals(DelayOptions.this.aceptar)){
                DelayOptions.this.hilo.setRetardo( Integer.valueOf(DelayOptions.this.texto.getText()).intValue() );
            }
            DelayOptions.this.dispose();
        }
    }
}
