package Interface.Options;

import Interface.*;

/**
 * Ventana para asignar el maximo de iteraciones
 * Created on 13 de febrero de 2005, 19:12
 * @author Jos Bladimir Contreras Vargas
 * @author <A HREF="mailto:jbc_ve@hotmail.com">jbc_ve@hotmail.com</A>
 */
public class MaxIterationOptions extends javax.swing.JFrame {
    /**
     * Texto para indicar el maximo de iteraciones
     */
    java.awt.TextField texto = new java.awt.TextField("          ");
    /**
     * Boton de aceptar
     */
    java.awt.Button aceptar = new java.awt.Button("Aceptar");
    /**
     * Boton cancelar
     */
    java.awt.Button cancelar = new java.awt.Button("Cancelar");
    /**
     * Hilo al cual se le debe asignar el maximo de iteraciones
     */
    Algorithms.RunFCM hilo;
    /**
     * Crea una nueva ventana para asignar el maximo de iteraciones
     * @param hilo Hilo al cual se le debe asignar el maximo de iteraciones
     */
    public MaxIterationOptions(Algorithms.RunFCM hilo) {
        Interface.LPanel panel = new Interface.LPanel();
        panel.addComponent( new java.awt.Label("Maximo de Iteraciones") , 1 , 0 , 1.0 , 1.0 , 0 , 0 );
        panel.addComponent( this.texto , 0 , 0 , 1.0 , 1.0 , 0 , 0 );
        panel.addComponent( this.aceptar, 1 , 0 , 1.0 , 1.0 , 0 , 0 );
        panel.addComponent( this.cancelar, 0 , 0 , 1.0 , 1.0 , 0 , 0 );
        this.add(panel);
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        this.aceptar.addMouseListener( new escucha() );
        this.cancelar.addMouseListener( new escucha() );
        this.pack();
        this.hilo = hilo;
        this.texto.setText( ""+this.hilo.getMaxIteraciones() );
        this.setTitle("Opciones de Iteraciones");
        this.setVisible(true);
        
    }
    
    /**
     * escucha del boton aceptar
     */
    private class escucha extends java.awt.event.MouseAdapter {
        /**
         * Acion de Clicar sobre el boton aceptar
         * @param evt enevto
         */
        public void mouseClicked(java.awt.event.MouseEvent evt) {
            if ( evt.getSource().equals(MaxIterationOptions.this.aceptar))
                MaxIterationOptions.this.hilo.setMaxIteraciones( Integer.valueOf(MaxIterationOptions.this.texto.getText()).intValue() );
            MaxIterationOptions.this.dispose();
        }
    }
   
}
