package PanelInterfaceMulticapa;

import java.awt.Dimension;
import java.awt.ScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import Map.Map;

@SuppressWarnings("serial")
public class PanelConstruccionRegla extends JPanel {
	
	private ArrayList<JPanel> listaPaneles=new ArrayList<JPanel>();
	private DefaultListModel modelo = new DefaultListModel();
	private JList listaReglas;
	private JPanel panelCostruirRegla;
	private JPanel panelReglasActuales;
	private JButton agregar=new JButton("Agergar");
	private JButton eliminar=new JButton("Eliminar");
	private Map mapa1;
	private Map mapa2;
	private int id;//0 conexion, 1 es ecuacion matematica y 2 reglas difusas

	public PanelConstruccionRegla(Map mapa1, Map mapa2,int id) {
		this.mapa1 = mapa1;
		this.mapa2 = mapa2;
		this.id=id;
		inicializarPaneles();
		this.add(agregarPaneles());
		eventos();
		agregarElemento();
	}
	
	private void inicializarPaneles(){
		panelCostruirRegla=new JPanel();
		panelReglasActuales=new JPanel();
		panelCostruirRegla.setSize(new Dimension(300,300));
	}
	
	private JPanel agregarPaneles(){
		JPanel panelCenter=new JPanel();
		llenarPanelReglasActual();
		panelCenter.add(panelReglasActuales);
		panelCenter.add(panelCostruirRegla);	
		return panelCenter;
	}
	
	private void llenarPanelReglasActual(){
		listaReglas=new JList(modelo);
		panelReglasActuales.setLayout(new BoxLayout(panelReglasActuales, BoxLayout.Y_AXIS));
		JLabel titulo=new JLabel("Regalas Actuales");
		titulo.setAlignmentX(RIGHT_ALIGNMENT);
		panelReglasActuales.add(titulo);
		panelReglasActuales.add(panelListaVisual());
		panelReglasActuales.add(panelBotones());
	}
	
	private JPanel panelBotones(){
		JPanel panelAux=new JPanel();
		panelAux.add(agregar);
		panelAux.add(eliminar);
		return panelAux;
	}
	
	private JPanel panelListaVisual(){
		JScrollPane panelAux=new JScrollPane(listaReglas);
		panelAux.setPreferredSize(new Dimension(150, 250));
		JPanel panelCenter=new JPanel();
		panelCenter.add(panelAux);
		return panelCenter;
	}
	
	private void eventos(){
		agregar.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				agregarElemento();
			}
		});
		
		eliminar.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				int pos=listaReglas.getSelectedIndex();
				if(pos!=-1){
					modelo.remove(pos);
					listaPaneles.remove(pos);
				}
				
			}
		});
		
		 listaReglas.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				int posicion =  listaReglas.getSelectedIndex();
				if (posicion != -1)
					cambiarPanel(listaPaneles.get(posicion));
			}
		});
	}
	
	private void cambiarPanel(JPanel panel){
		panelCostruirRegla.removeAll();
		panelCostruirRegla.add(panel);
		panelCostruirRegla.updateUI();
	}
	
	private void agregarElemento(){
		cualElemento();
		otrosElementos();
	}
	
	private void cualElemento(){
		switch (id) {
		case 0:
			listaPaneles.add(new PanelReglaConexion(mapa1, mapa2));
			break;
			
		case 1:
			listaPaneles.add(new PanelReglaEcuacion(mapa1, mapa2));
			break;

		default:
			listaPaneles.add(new PanelReglaDifusa(mapa1, mapa2));
			break;
		}	
	}
	
	private void otrosElementos(){
		modelo.addElement("regla");
		listaReglas.setSelectedIndex(listaPaneles.size()-1);
		cambiarPanel(listaPaneles.get(listaPaneles.size()-1));
	}
	
	public ArrayList<JPanel> getListaPanel(){
		return listaPaneles;
	}
}
