package PanelInterfaceMulticapa;

import java.awt.FileDialog;
import java.awt.Frame;
import java.awt.Label;
import java.awt.ScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import Interface.MapCanvas;
import Map.Map;

public class PanelMapaCargado extends JPanel {

	private JLabel title;
	private JButton vista;
	private JButton cargar;
	private JComboBox normalizacion;
	private JLabel imagenMapa;
	private JTextField iteraciones;
	private MapCanvas mapCanvas;
	private Boolean bandera=false;
	private JFrame principal;

	public PanelMapaCargado(String nombre, Boolean flag,JFrame principal) {
		this.principal=principal;
		title = new JLabel(nombre);
		mapCanvas = new MapCanvas(new Map(flag));
		inicializar();
		this.add(panelCentral());
		eventos();
	}

	private void inicializar() {
		vista = new JButton("Vista");
		cargar = new JButton("Cargar");
		iteraciones = new JTextField(4);
		iteraciones.setText("10");
		imagenMapa = new JLabel();
		imagenMapa.setIcon(new ImageIcon("cargar.png"));
		llenarComboBox();
	}

	private void llenarComboBox() {
		normalizacion = new JComboBox();
		normalizacion.addItem("Sy");
		normalizacion.addItem("Saturacion");
		normalizacion.addItem("TriState");
		normalizacion.addItem("BiState");
		normalizacion.setSelectedIndex(1);
	}

	private JPanel panelCentral() {
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		title.setAlignmentX(CENTER_ALIGNMENT);
		imagenMapa.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(title);
		panelAux.add(new JLabel("         "));
		panelAux.add(imagenMapa);
		panelAux.add(PanelBotones());
		panelAux.add(panelConfiguracion());
		return panelAux;
	}

	private JPanel panelConfiguracion() {
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		panelAux.add(new Label("Asignar Normalizacion"));
		panelAux.add(normalizacion);
		panelAux.add(new Label("Iteraciones"));
		panelAux.add(iteraciones);
		return panelAux;
	}

	private JPanel PanelBotones() {
		JPanel panelAux = new JPanel();
		panelAux.add(cargar);
		panelAux.add(vista);
		return panelAux;
	}

	private void eventos(){
		
		cargar.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				cargarMapa();
			}
		});

		vista.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				pintarMapa();

			}
		});	
	}

	private void cargarMapa() {
		Frame f = new Frame();
		FileDialog dialogo = new FileDialog(f, "Abrir Mapa", FileDialog.LOAD);
		dialogo.setVisible(true);
		if(dialogo.getDirectory()!=null){
			mapCanvas.getMap().load(dialogo.getDirectory(), dialogo.getFile());
			imagenMapa.setIcon(new ImageIcon("mapaCargado.png"));	
			bandera=true;
		}
	}

	private void pintarMapa() {
		JDialog ventana = new JDialog(principal, "Vista del Mapa", true);
		ventana.add(panelMapa());
		ventana.setLocationRelativeTo(null);
		ventana.setSize(600, 600);
		ventana.setVisible(true);
	}
	
	private ScrollPane panelMapa(){
		ScrollPane scrollPane = new ScrollPane();
		scrollPane.add(mapCanvas);
		return scrollPane;
	}

	public MapCanvas getMapCanvas() {
		return mapCanvas;
	}

	public String getIteracion() {
		return iteraciones.getText();
	}

	public int getNormalizacion() {
		return normalizacion.getSelectedIndex() + 1;
	}

	public Boolean getBandera(){
		return bandera;
	}
}
