package PanelInterfaceMulticapa;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import Map.Concept;
import Map.Map;

public class PanelReglaConexion extends JPanel {

	private Map mapa1;
	private Map mapa2;
	private JComboBox comboBox1;
	private JComboBox comboBox2;
	private JTextField peso;
	private JButton botonDireccion;
	private Boolean bandera = true;// derecha a izquierda

	public PanelReglaConexion(Map mapa1, Map mapa2) {
		this.mapa1 = mapa1;
		this.mapa2 = mapa2;
		inicializar();
		add(panelCentral());
	}

	private void inicializar() {
		botonDireccion = new JButton();
		botonDireccion.setIcon(new ImageIcon("flecha1.png"));
		peso = new JTextField(5);
		llenarComboBox();
		eventos();
	}

	private void llenarComboBox() {
		comboBox1 = new JComboBox();
		comboBox2 = new JComboBox();
		Concept aux;
		for (Object object : mapa1.getConceptList()) {
			aux = (Concept) object;
			comboBox1.addItem(aux.getName());
		}

		for (Object object : mapa2.getConceptList()) {
			aux = (Concept) object;
			comboBox2.addItem(aux.getName());
		}

	}

	private void eventos() {
		botonDireccion.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (bandera) {
					bandera = false;
					botonDireccion.setIcon(new ImageIcon("flecha2.png"));
				} else {
					bandera = true;
					botonDireccion.setIcon(new ImageIcon("flecha1.png"));
				}

			}
		});
	}
	
	private JPanel panelCentral(){
		JPanel panelAux=new JPanel();
		JLabel titulo=new JLabel("Configuracion de Regla");
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		titulo.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(titulo);
		panelAux.add(panelComponentes());
		return panelAux;
	}
	
	private JPanel panelComponentes(){
		JPanel panelAux=new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		JLabel titulo1=new JLabel("Mapa 1");
		titulo1.setAlignmentX(CENTER_ALIGNMENT);
		JLabel titulo2=new JLabel("Mapa 2");
		titulo2.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(titulo1);
		panelAux.add(comboBox1);
		panelAux.add(panelPesoCompleto());
		panelAux.add(titulo2);
		panelAux.add(comboBox2);
		return panelAux;
	}
	
	private JPanel panelPesoCompleto(){
		JPanel panelAux=new JPanel();
		botonDireccion.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(panelPeso());
		panelAux.add(botonDireccion);
		return panelAux;
	}
	
	private JPanel panelPeso(){
		JPanel panelAux=new JPanel();
		JLabel tituloPeso=new JLabel("Peso");
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		tituloPeso.setAlignmentX(CENTER_ALIGNMENT);
		peso.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(tituloPeso);
		panelAux.add(peso);
		return panelAux;
	}
	
	public Map getMapa1(){
		return mapa1;
	}
	public Map getMapa2(){
		return mapa2;
	}
	public Boolean getBandera(){
		return bandera;
	}
	public Float getPeso(){
		return Float.parseFloat(peso.getText());
	}
	public int getSelectedComboBox1(){
		return comboBox1.getSelectedIndex();
	}
	public int getSelectedComboBox2(){
		return comboBox2.getSelectedIndex();
	}
	
	public Boolean validar(JPanel panel){
		if(!comprobarFloat(peso.getText())){
			JOptionPane jop = new JOptionPane();
			jop.showMessageDialog(
					panel,
					"los valores de los pesos deben ser digitos(enteros o flotantes) ",
					"Error en Construccion de Reglas de Conexion",
					JOptionPane.ERROR_MESSAGE);
			return false;
		}
		
		return true;
	}
	
	@SuppressWarnings("unused")
	public boolean comprobarFloat(String cadena) {
		try {
			float num = Float.parseFloat(cadena);
		} catch (Exception e) {
			return false;
		}
		return true;

	}

}
