package PanelInterfaceMulticapa;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import Map.Concept;
import Map.Map;

@SuppressWarnings("serial")
public class PanelReglaDifusa extends JPanel {

	private JButton agergarArchivoRegla = new JButton("Buscar Archivo .fis");
	private JLabel archivoSel = new JLabel("Archivo: Ninguno");
	private JButton agregarVariable = new JButton("Agregar");
	private JComboBox comboBoxMapa1;
	private JComboBox comboBoxMapa2;
	private JPanel panelComboBox;
	private JPanel panelComboBoxAux = new JPanel();
	private Map mapa1;
	private Map mapa2;
	private JRadioButton opcionMapa1 = new JRadioButton("Mapa1");
	private JRadioButton opcionMapa2 = new JRadioButton("Mapa2");
	private DefaultListModel modelo = new DefaultListModel();
	private JList listaVariables = new JList(modelo);
	private String rutaArchivo;
	private JButton eliminar=new JButton("Eliminar");
	private ArrayList<Concept> paramteros;

	public PanelReglaDifusa(Map mapa1, Map mapa2) {
		this.mapa1 = mapa1;
		this.mapa2 = mapa2;
		paramteros=new ArrayList<Concept>();
		llenarComboBox();
		this.add(panelComponentes());
	}

	private void llenarComboBox() {
		comboBoxMapa1 = new JComboBox();
		comboBoxMapa2 = new JComboBox();
		Concept aux;
		for (Object object : mapa1.getConceptList()) {
			aux = (Concept) object;
			comboBoxMapa1.addItem(aux.getName());
		}

		for (Object object : mapa2.getConceptList()) {
			aux = (Concept) object;
			comboBoxMapa2.addItem(aux.getName());
		}
	}

	private JPanel panelComponentes() {
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		panelAux.add(variableInteres());
		panelAux.add(archivoReglas());
		panelAux.add(agregarVariables());
		eventos();
		return panelAux;
	}

	private JPanel archivoReglas() {
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		JLabel separador1 = new JLabel("  ");
		separador1.setPreferredSize(new Dimension(50, 50));
		agergarArchivoRegla.setAlignmentX(CENTER_ALIGNMENT);
		archivoSel.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(separador1);
		panelAux.add(agergarArchivoRegla);
		panelAux.add(archivoSel);
		return panelAux;
	}

	private JPanel variableInteres() {
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		panelAux.add(radioButton());
		panelComboBox = new JPanel();
		panelComboBox.add(comboBoxMapa1);
		panelAux.add(panelComboBox);
		return panelAux;
	}

	private JPanel agregarVariables() {
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		JLabel titulo = new JLabel("Variables del Sistema Difuso");
		titulo.setAlignmentX(CENTER_ALIGNMENT);
		eliminar.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(titulo);
		panelAux.add(variables());
		JScrollPane panelLista = new JScrollPane(listaVariables);
		panelLista.setPreferredSize(new Dimension(300, 100));
		JPanel panelCenter=new JPanel();
		panelCenter.add(panelLista);
		panelAux.add(panelCenter);
		panelAux.add(eliminar);
		return panelAux;
	}

	private JPanel variables() {
		JPanel panelAux = new JPanel();
		panelComboBoxAux.add(comboBoxAux());
		panelAux.add(panelComboBoxAux);
		panelAux.add(agregarVariable);
		return panelAux;
	}

	private JPanel radioButton() {

		ButtonGroup group = new ButtonGroup();
		opcionMapa1.setSelected(true);
		JPanel panel1 = new JPanel();
		group.add(opcionMapa1);
		group.add(opcionMapa2);
		panel1.add(new JLabel("Variable de interes: "));
		panel1.add(opcionMapa1);
		panel1.add(opcionMapa2);
		return panel1;
	}

	private void eventos() {
		opcionMapa1.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				panelComboBox.removeAll();
				panelComboBox.add(comboBoxMapa1);
				panelComboBox.updateUI();

				panelComboBoxAux.removeAll();
				panelComboBoxAux.add(comboBoxMapa2);
				panelComboBoxAux.updateUI();
			}
		});

		opcionMapa2.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				panelComboBox.removeAll();
				panelComboBox.add(comboBoxMapa2);
				panelComboBox.updateUI();

				panelComboBoxAux.removeAll();
				panelComboBoxAux.add(comboBoxMapa1);
				panelComboBoxAux.updateUI();
			}
		});

		agregarVariable.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				modelo.addElement("imput = "
						+ comboBoxAux().getSelectedItem());
				paramteros.add(buscarConcepto(comboBoxAux().getSelectedIndex()));
				opcionMapa1.setEnabled(false);
				opcionMapa2.setEnabled(false);
			}
		});

		agergarArchivoRegla.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				cargarArchivo();

			}
		});
		
		eliminar.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int posicion=listaVariables.getSelectedIndex();
				if(posicion!=-1){
					modelo.remove(posicion);
					paramteros.remove(posicion);
				}
				
			}
		});
	}

	private void cargarArchivo() {
		JFrame ventana = new JFrame();
		JFileChooser fileChooser = new JFileChooser();
		int seleccion = fileChooser.showOpenDialog(ventana);
		if (seleccion == JFileChooser.APPROVE_OPTION) {
			File fichero = fileChooser.getSelectedFile();
			if (validar(fichero)) {
				rutaArchivo = fichero.getAbsolutePath();
				archivoSel.setText("Archivo: " + rutaArchivo);
			}
		}
	}

	private JComboBox comboBoxAux() {
		if (opcionMapa1.isSelected())
			return comboBoxMapa2;
		else
			return comboBoxMapa1;
	}

	private Concept buscarConcepto(int pos) {
		if (opcionMapa1.isSelected())
			return (Concept) mapa2.getConceptList().get(pos);
		else
			return (Concept) mapa1.getConceptList().get(pos);
	}
	
	private Boolean validar(File fichero) {
		String aux1, aux2;
		aux1 = fichero.getAbsolutePath();
		if (aux1.length() > 3) {
			aux2 = aux1.substring(aux1.length() - 3, aux1.length());
			if (aux2.equals("fis"))
				return true;
		}

		return false;
	}
	

	public String getRutaArchivo() {
		return rutaArchivo;
	}

	public void setRutaArchivo(String rutaArchivo) {
		this.rutaArchivo = rutaArchivo;
	}
	
	public Concept getMapDestino(){
		if (opcionMapa1.isSelected())
			return (Concept) mapa1.getConceptList().get(comboBoxMapa1.getSelectedIndex());
		else
			return (Concept) mapa2.getConceptList().get(comboBoxMapa2.getSelectedIndex());
	}
	
	public int idMapaDestino(){
		if (opcionMapa1.isSelected()) {
			return 1;
		} else {
			return 2;
		}
	}
	
	public ArrayList<Concept> getParamteros(){
		return paramteros;
	}
}
