package PanelInterfaceMulticapa;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import Interface.MultiCapas.MapeoConceptos;
import Map.Concept;
import Map.Map;

@SuppressWarnings("serial")
public class PanelReglaEcuacion extends JPanel {

	private JTextArea ecuacion = new JTextArea();
	private JButton eliminar = new JButton("Eliminar");
	private JButton agregarVariable = new JButton("Agregar Variable");
	private JComboBox comboBoxMapa1;
	private JComboBox comboBoxMapa2;
	private JPanel panelComboBox;
	private JPanel panelComboBoxAux = new JPanel();
	private Map mapa1;
	private Map mapa2;
	private JRadioButton opcionMapa1 = new JRadioButton("Mapa1");
	private JRadioButton opcionMapa2 = new JRadioButton("Mapa2");
	private DefaultListModel modelo = new DefaultListModel();
	private JList listaVariables = new JList(modelo);
	private JTextField valor = new JTextField(4);
	private ArrayList<MapeoConceptos> listaMapeo = new ArrayList<MapeoConceptos>();

	public PanelReglaEcuacion(Map mapa1, Map mapa2) {
		this.mapa1 = mapa1;
		this.mapa2 = mapa2;
		llenarComboBox();
		this.add(panelEcuacion());
	}

	private void llenarComboBox() {
		comboBoxMapa1 = new JComboBox();
		comboBoxMapa2 = new JComboBox();
		Concept aux;
		for (Object object : mapa1.getConceptList()) {
			aux = (Concept) object;
			comboBoxMapa1.addItem(aux.getName());
		}

		for (Object object : mapa2.getConceptList()) {
			aux = (Concept) object;
			comboBoxMapa2.addItem(aux.getName());
		}

	}

	private JPanel panelEcuacion() {
		JScrollPane panel = new JScrollPane(ecuacion);
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		panel.setPreferredSize(new Dimension(300, 50));
		panelAux.add(variableInteres());
		panelAux.add(panel);
		panelAux.add(agregarVariables());
		eventos();
		return panelAux;
	}

	private JPanel radioButton() {

		ButtonGroup group = new ButtonGroup();
		opcionMapa1.setSelected(true);
		JPanel panel1 = new JPanel();
		group.add(opcionMapa1);
		group.add(opcionMapa2);
		panel1.add(new JLabel("Variable de interes: "));
		panel1.add(opcionMapa1);
		panel1.add(opcionMapa2);
		return panel1;
	}

	private void eventos() {
		opcionMapa1.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				panelComboBox.removeAll();
				panelComboBox.add(comboBoxMapa1);
				panelComboBox.updateUI();

				panelComboBoxAux.removeAll();
				panelComboBoxAux.add(comboBoxMapa2);
				panelComboBoxAux.updateUI();
			}
		});

		opcionMapa2.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				panelComboBox.removeAll();
				panelComboBox.add(comboBoxMapa2);
				panelComboBox.updateUI();

				panelComboBoxAux.removeAll();
				panelComboBoxAux.add(comboBoxMapa1);
				panelComboBoxAux.updateUI();
			}
		});

		agregarVariable.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (validar()) {
					modelo.addElement(valor.getText() + "="
							+ comboBoxAux().getSelectedItem());
					listaMapeo.add(new MapeoConceptos(
							buscarConcepto(comboBoxAux().getSelectedIndex()),
							valor.getText()));
					cambiarEstado();
				}
			}
		});

		eliminar.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				int pos = listaVariables.getSelectedIndex();
				if (listaVariables.getSelectedIndex() != -1) {
					modelo.remove(pos);
					listaMapeo.remove(pos);
					cambiarEstado();
				}

			}
		});
	}

	private void cambiarEstado() {
		if (modelo.size() > 0) {
			opcionMapa1.setEnabled(false);
			opcionMapa2.setEnabled(false);
		} else {
			opcionMapa1.setEnabled(true);
			opcionMapa2.setEnabled(true);
		}
	}

	private JPanel variableInteres() {
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		panelAux.add(radioButton());
		panelComboBox = new JPanel();
		panelComboBox.add(comboBoxMapa1);
		panelAux.add(panelComboBox);
		return panelAux;
	}

	private JPanel agregarVariables() {
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		JLabel titulo = new JLabel("Variables de la Formula");
		titulo.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(titulo);
		panelAux.add(variables());
		agregarVariable.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(agregarVariable);
		JScrollPane panelLista = new JScrollPane(listaVariables);
		panelLista.setPreferredSize(new Dimension(200, 100));
		panelAux.add(panelLista);
		eliminar.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(eliminar);
		return panelAux;
	}

	private JPanel variables() {
		JPanel panelAux = new JPanel();
		panelComboBoxAux.add(comboBoxAux());
		panelAux.add(panelComboBoxAux);
		panelAux.add(valor);
		return panelAux;
	}

	private JComboBox comboBoxAux() {
		if (opcionMapa1.isSelected())
			return comboBoxMapa2;
		else
			return comboBoxMapa1;
	}

	private Concept buscarConcepto(int pos) {
		if (opcionMapa1.isSelected())
			return (Concept) mapa2.getConceptList().get(pos);
		else
			return (Concept) mapa1.getConceptList().get(pos);
	}

	@SuppressWarnings("static-access")
	private Boolean validar() {
		JOptionPane jop = new JOptionPane();
		if (valor.getText().isEmpty()) {
			jop.showMessageDialog(
					this,
					"El campo no puede estar vacio",
					"Error Variables", JOptionPane.ERROR_MESSAGE);
			return false;
		}
		if (comprobarFloat()) {
			jop.showMessageDialog(this,
					"Las variables no pueden iniciar con digitos",
					"Error Variables", JOptionPane.ERROR_MESSAGE);
			return false;
		}
		return true;
	}

	@SuppressWarnings("unused")
	private boolean comprobarFloat() {
		String cadena = valor.getText().substring(0, 1);
		try {
			float num = Float.parseFloat(cadena);
		} catch (Exception e) {
			return false;
		}
		return true;
	}
	
	public String getEcuacion(){
		return ecuacion.getText();
	}
	
	public Concept getMapDestino(){
		if (opcionMapa1.isSelected())
			return (Concept) mapa1.getConceptList().get(comboBoxMapa1.getSelectedIndex());
		else
			return (Concept) mapa2.getConceptList().get(comboBoxMapa2.getSelectedIndex());
	}
	
	public int idMapaDestino(){
		if (opcionMapa1.isSelected()) {
			return 1;
		} else {
			return 2;
		}
	}
	
	public ArrayList<MapeoConceptos> getMapeoConceptos(){
		return listaMapeo;
	}

}