package PanelInterfaceMulticapa;

import java.awt.Dimension;
import java.awt.ScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import Interface.MapCanvas;
import Interface.MultiCapas.InterfazMultiCapas;
import Map.Concept;

public class PanelResultados extends JPanel{
	private InterfazMultiCapas interfazMultiCapas;
	private JTable tabla;
	private DefaultTableModel datos;
	private JButton vistaMapa1=new JButton("Arcos Mapa 1");
	private JButton vistaMapa2=new JButton("Arcos Mapa 2");

	public PanelResultados(InterfazMultiCapas interfazMultiCapas) {
		this.interfazMultiCapas = interfazMultiCapas;
		llenarTabla();
		this.add(panelCentral());
	}

	private void llenarTabla() {
		ArrayList<Concept> listconcepts1;
		listconcepts1 = interfazMultiCapas.getMap(1).getConceptList();
		ArrayList<Concept> listconcepts2;
		listconcepts2 = interfazMultiCapas.getMap(2).getConceptList();
		
		int tam1 = listconcepts1.size();
		int tam2 = listconcepts2.size();
		String[] encabezado = new String[tam1 + tam2+1];
		encabezado[0]="Iteracion";
		int i = 1;
		for (Concept c : listconcepts1) {
			encabezado[i] = c.getName();
			i++;
		}

		for (Concept c : listconcepts2) {
			encabezado[i] = c.getName();
			i++;
		}
		datos = new DefaultTableModel(encabezado, 1);
		datos.removeRow(0);
		tabla = new JTable(datos);
		tabla.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		tabla.setAlignmentX(CENTER_ALIGNMENT);
		tabla.setEnabled(false);
	}

	private void cargarInformacion(){
		ArrayList<ArrayList<Float>> listaFinal;
		listaFinal=interfazMultiCapas.getListaFinal();
		int i=1;
		for (ArrayList<Float> lA : listaFinal) {
			addElemento(lA, i);
			i++;
		}
	}
	
	private void addElemento(ArrayList<Float> lA, int iteracion) {
		Object[] valor= new Object[lA.size()+1];
		valor[0]=iteracion;
		int i=1;
		for (Float f : lA) {
			valor[i]=f;
			i++;
		}
		datos.addRow(valor);
	}

	private JPanel panelTabla() {
		cargarInformacion();
		JPanel panelAux = new JPanel();
		JScrollPane scrollPane = new JScrollPane(tabla);
		scrollPane.setPreferredSize(new Dimension(600,200));
		panelAux.add(scrollPane);
		return panelAux;
	}
	
	private JPanel panelinformacion(ArrayList<Concept> listaConceptos){
		DefaultListModel modelo = new DefaultListModel();
		JList lista=new JList(modelo);
		JScrollPane paneLista=new JScrollPane(lista);
		paneLista.setPreferredSize(new Dimension(250, 200));
		llenarlista(listaConceptos, modelo);
		JPanel panelAux = new JPanel();
		panelAux.add(paneLista);
		return panelAux;
	}
	
	private void llenarlista(ArrayList<Concept> listaConceptos,DefaultListModel modelo){
		for (Concept concept : listaConceptos) {
			modelo.addElement(concept.getName());
		}
	}
	
	private JPanel panelMapa(String titulo,ArrayList<Concept> listaConceptos){
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		JLabel tituloPanle=new JLabel(titulo);
		tituloPanle.setAlignmentX(CENTER_ALIGNMENT);
		panelAux.add(tituloPanle);
		panelAux.add(panelinformacion(listaConceptos));
		return panelAux;
	}
	
	private JPanel panelInferior(){
		ArrayList<Concept> listconcepts1;
		listconcepts1 = interfazMultiCapas.getMap(1).getConceptList();
		ArrayList<Concept> listconcepts2;
		listconcepts2 = interfazMultiCapas.getMap(2).getConceptList();
		JPanel panelAux = new JPanel();
		panelAux.add(panelMapa("Conceptos de Mapa1", listconcepts1));
		panelAux.add(new JLabel("           "));
		panelAux.add(panelMapa("Conceptos de Mapa2", listconcepts2));
		return panelAux;
	}
	
	private JPanel panelSuperior(){
		JLabel titulo=new JLabel("Tabla de Resultados del Sistema Multi-Capa");
		titulo.setAlignmentX(CENTER_ALIGNMENT);
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		panelAux.add(titulo);
		panelAux.add(panelTabla());
		return panelAux;
	}
	
	private JPanel panelCentral(){
		JPanel panelAux = new JPanel();
		panelAux.setLayout(new BoxLayout(panelAux, BoxLayout.Y_AXIS));
		panelAux.add(panelSuperior());
		panelAux.add(panelVistaMapa());
		panelAux.add(panelInferior());
		return panelAux;
	}
	
	private JPanel panelVistaMapa(){
		JPanel panelAux = new JPanel();
		panelAux.add(vistaMapa1);
		panelAux.add(new JLabel("       "));
		panelAux.add(vistaMapa2);
		eventos();
		return panelAux;
	}
	
	
	private void pintarMapa(MapCanvas mapCanvas) {
		JDialog ventana = new JDialog(interfazMultiCapas.getPrincipal(), "Vista Final del Mapa", true);
		ventana.add(panelMapa(mapCanvas));
		ventana.setLocationRelativeTo(null);
		ventana.setSize(600, 600);
		ventana.setVisible(true);
	}
	
	private ScrollPane panelMapa(MapCanvas mapCanvas){
		ScrollPane scrollPane = new ScrollPane();
		scrollPane.add(mapCanvas);
		return scrollPane;
	}
	
	private void eventos(){
		vistaMapa1.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				pintarMapa(interfazMultiCapas.getMapaCanvas(1));
				
			}
		});
		
		vistaMapa2.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				pintarMapa(interfazMultiCapas.getMapaCanvas(2));
				
			}
		});
	}

}
