/**
 * Applet Inicial para la generacion inicial de las ventanas
 * Created on 24 de enero de 2005, 20:26
 * @author <A HREF="mailto:jbc_ve@hotmail.com">jbc_ve@hotmail.com</A>
 * @author Jos Bladimir Contreras Vargas
 */
public class FCM extends java.applet.Applet {
    
    /**
     * Contador de Cuantos Apples han sido creados
     */
    private int appCount = 0;       //Cunta cuantoa apples hay en memoria
    /**
     * Indica si un applet o una ejecucin
     */
    private boolean isApp = false;  //detrermina si se ejecuto el aplet desde el navegador o como aplicacion
    /**
     * Frame que contiene el applet
     */
    private javax.swing.JFrame frame;            //frame inicial si se ejecuta como aplicaion
    
    /**
     * Metodo de inicializacion del applet
     * Craga una ventana inical para:
     * salir del sistema
     * Cargar una ventana para FCM
     * Cargar una ventana para DFCM
     */
    public void init (){
        java.awt.Button fcm = new java.awt.Button ("Nuevo FCM");
        java.awt.Button dfcm = new java.awt.Button ("Nuevo DFCM");
        EscuchaCrearVentana ventana = new EscuchaCrearVentana();
        fcm.addActionListener( ventana );
        dfcm.addActionListener( ventana );
        java.awt.Button salir = new java.awt.Button ("Salir");
        salir.addActionListener( new EscuchaBotonSalir() );
        if(isApp)
         {         
            this.setLayout(new java.awt.GridLayout(3,1));
            this.add( dfcm );
            this.add( fcm );
            this.add( salir );
         }
         else
         {
            this.setLayout(new java.awt.GridLayout(2,1));
            this.add( dfcm );
            this.add( fcm );
         }

	 this.validate();
         this.setVisible(true);
    }

    /**
     * Punto de inicializacion cuando es arrancado 
     * como un programa
     * @param args No es utilizado
     */
    public static void main ( String [] args ){     
        FCM map = new FCM();
        map.isApp = true;
        map.launchFrame();   
    }
    
    /**
     *Carga del Frame
     */
    public void launchFrame (){
        frame = new javax.swing.JFrame ("Start");
        this.init();
        this.start();        
        frame.add("Center", this );
        frame.setSize(140, 150);
        frame.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        frame.setVisible(true);  
    }
    
    /**
     * Crea Una ventana para el manejo de un FCM
     * @return Retorna la ventana
     */
    private Interface.MapWindow buildWindowFCM(){ 
        Interface.MapWindow VentanaDelMapa = new Interface.MapWindow( false );
  
        VentanaDelMapa.setTitle("FCM Designer - No Name - Versin 1.0");
        
        VentanaDelMapa.setSize(750 , 550 );
        
        VentanaDelMapa.setVisible(true);
        return VentanaDelMapa;
    }
    
    /**
     * Crea Una ventana para el manejo de un DFCM
     * @return retorna la ventana
     */
    private Interface.MapWindow buildWindowDFCM(){ 
        Interface.MapWindow VentanaDelMapa = new Interface.MapWindow( true );
  
        VentanaDelMapa.setTitle("DFCM Designer - No Name - Versin 1.0");
        
        VentanaDelMapa.setSize(750 , 550 );
        
        VentanaDelMapa.setVisible(true);
        return VentanaDelMapa;
    }
    
    /**
     *Clase Salir utilizada para botones que terminan la 
     *aplicacin por completo 
     */
    private class EscuchaBotonSalir implements java.awt.event.ActionListener {
        /**
         * ccion de presionar en el boton salir
         * @param e evento
         */
        public void actionPerformed ( java.awt.event.ActionEvent e ){
            System.exit(0);
        }
    }
    
    /**
     *Clase Crear Ventana utilizada para el boton e inicializar
     *la ventana de diseo del FCM
     */
    private class EscuchaCrearVentana implements java.awt.event.ActionListener {
        /**
         * Crea la ventana para el FCM o el DFCM
         * @param e evento de preionar el boon
         */
        public void actionPerformed ( java.awt.event.ActionEvent e ){
            if ( ((java.awt.Button)e.getSource()).getLabel().equals("Nuevo FCM") )
                FCM.this.buildWindowFCM();
            else
                FCM.this.buildWindowDFCM();
        }
    }
}
