package Interface.Options;

/**
 * Ventana para modificar las relaciones 
 * Created on 1 de febrero de 2005, 8:20
 * @author Jos Bladimir Contreras Vargas
 * @author <A HREF="mailto:jbc_ve@hotmail.com">jbc_ve@hotmail.com</A>
 */
public class RelationOptions extends javax.swing.JFrame {
    /**
     * Boton aceptar
     */
    private javax.swing.JButton botonAceptar;
    /**
     * Boton Cancelar
     */
    private javax.swing.JButton botonCancelar;   
    /**
     * entrada de la etiqueta de porcentaje de aproximacin
     */
    private javax.swing.JTextField porcentajeTextField;   
    /**
     * Entrada del valor
     */
    private javax.swing.JTextField valorTextField;
    /**
     * Relacin a modificar
     */
    private Map.Relation relation;
    /**
     * lienzo donde esta dibujada la relacin
     */
    private java.awt.Canvas canvas;
  
    private java.awt.TextArea comentario;
    /**
     * Crea una nueva ventana para modificar los parametros de la relacin
     * @param e Relacion a modificar
     * @param c Lienzo donde esta dibujada la relacin
     */
    public RelationOptions( Map.Relation e , java.awt.Canvas c ) {
        this.relation = e;
        this.canvas = c;
        initComponents();
        
    }
    
    /**
     * Inicializa los componentes de la ventana
     */
    private void initComponents() {
        javax.swing.JLabel idLabel = new javax.swing.JLabel();
        javax.swing.JLabel idValue = new javax.swing.JLabel();
        javax.swing.JLabel valorLabel = new javax.swing.JLabel();
        valorTextField = new javax.swing.JTextField();
        javax.swing.JLabel porcentajeLabel = new javax.swing.JLabel();
        porcentajeTextField = new javax.swing.JTextField();
        botonCancelar = new javax.swing.JButton();
        botonAceptar = new javax.swing.JButton();

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Opciones Para Relaciones");
        setName("edgeOptions");
        idLabel.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        idLabel.setText("Identifacador del Eje:");
        idLabel.setFocusable(false);
        getContentPane().add(idLabel);
        idLabel.setBounds(30, 10, 130, 14);

        idValue.setText("" + this.relation.getRelationId() );
        getContentPane().add(idValue);
        idValue.setBounds(170, 10, 40, 14);

        valorLabel.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        if ( this.relation.isDynamic() )
            valorLabel.setText("Entrada:");
        else
            valorLabel.setText("Valor:");
        
        getContentPane().add(valorLabel);
        valorLabel.setBounds(10, 50, 54, 14);

        if ( this.relation.isDynamic() ){
            valorTextField.setToolTipText("Peso del Eje [0, 1]");
            valorTextField.setText( ""+this.relation.getDinamicImput() );
        }
        else{
            valorTextField.setToolTipText("Valor del Eje [0, 1]");
            valorTextField.setText( ""+this.relation.getValue() );
        }
        
        getContentPane().add(valorTextField);
        valorTextField.setBounds(70, 50, 100, 19);

        porcentajeLabel.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        porcentajeLabel.setText("Porcentaje de Aproximaci\u00f3n:");
        getContentPane().add(porcentajeLabel);
        porcentajeLabel.setBounds(10, 90, 170, 14);

        porcentajeTextField.setText(""+this.relation.getPorcentajeAproximacion() );
        getContentPane().add(porcentajeTextField);
        porcentajeTextField.setBounds(180, 90, 40, 19);

        javax.swing.JLabel etiqueta = new javax.swing.JLabel( "Comentario:" ); 
        etiqueta.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));  
        this.getContentPane().add(etiqueta);  
        etiqueta.setBounds( 10 , 120 , 119 , 14 );  
        
        comentario = new java.awt.TextArea ( this.relation.getComentario() ); 
        this.getContentPane().add(comentario);
        comentario.setBounds( 10 , 140 , 230 , 100 );
        
        botonCancelar.setText("Cancelar");
        
        botonCancelar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botonCancelarEvent( );
            }
        });

        getContentPane().add(botonCancelar);
        botonCancelar.setBounds(120, 250, 90, 23);

        botonAceptar.setText("Aceptar");
        
        botonAceptar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botonAceptarEvent();
            }
        });

        getContentPane().add(botonAceptar);
        botonAceptar.setBounds(20, 250, 90, 23);

        this.setSize( 250 , 320 );
        this.setLocation( 100 , 100 );
        this.setTitle("Opciones de la Relacin");
    }

    /**
     * al presionar el boton cancelar se cierra la ventana
     */
    private void botonCancelarEvent() {
        this.dispose();
    }

    /**
     * al presionar el boton cancelar se cierra la ventana y se aplican los cambios
     */
    private void botonAceptarEvent() {
        
        if ( this.relation.isDynamic() )
            this.relation.setDinamicImput( Float.valueOf( this.valorTextField.getText() ) );
        else
            this.relation.setValor( Float.valueOf( this.valorTextField.getText() ) );
        
        this.relation.setPorcentajeAproximacion( Float.valueOf( this.porcentajeTextField.getText()));
        this.relation.setComentario( this.comentario.getText() ); 
        this.canvas.repaint();
        this.dispose();
    }
    
}
